Skip to main content

List all materialized tables

GET 

/sql/v1/organizations/:organization_id/environments/:environment_id/materialized-tables

General Availability

Retrieve a sorted and paginated list of all materialized tables.

Request

Responses

A list of Materialized Tables.

Response Headers
    X-Request-Id

    The unique identifier for the API request.

OpenAPI definition (YAML)
paths:
  /sql/v1/organizations/{organization_id}/environments/{environment_id}/materialized-tables:
    get:
      x-lifecycle-stage: General Availability
      x-self-access: true
      x-request-access-name: SQL API v1
      operationId: listSqlv1MaterializedTables
      description: '[![General Availability](https://img.shields.io/badge/Lifecycle%20Stage-General%20Availability-%2345c6e8)](#section/Versioning/API-Lifecycle-Policy)


        Retrieve a sorted and paginated list of all materialized tables.

        '
      parameters:
      - in: path
        name: organization_id
        schema:
          type: string
          format: uuid
        required: true
        description: The unique identifier for the organization.
      - in: path
        name: environment_id
        required: true
        schema:
          type: string
        description: The unique identifier for the environment.
      - name: page_size
        in: query
        required: false
        schema:
          type: integer
          format: int32
          default: 10
          maximum: 100
        description: A pagination size for collection requests.
      - name: page_token
        in: query
        required: false
        schema:
          type: string
          maxLength: 255
        description: An opaque pagination token for collection requests.
      tags:
      - Materialized Tables (sql/v1)
      security:
      - resource-api-key: []
      - global-api-key: []
      - external-access-token: []
      responses:
        '200':
          description: A list of Materialized Tables.
          content:
            application/json:
              schema:
                type: object
                description: A list of Materialized Table resources.
                required:
                - api_version
                - kind
                - metadata
                - data
                properties:
                  api_version:
                    type: string
                    enum:
                    - sql/v1
                    readOnly: true
                  kind:
                    type: string
                    enum:
                    - MaterializedTableList
                    readOnly: true
                  metadata:
                    type: object
                    description: ListMeta describes metadata that resource collections may have
                    properties:
                      first:
                        description: A link to the first page of results. If a response does not contain
                          a first link, then direct navigation to the first page is not supported.
                        type: string
                        format: uri
                        nullable: true
                        example: https://api.confluent.cloud/v2/resourcekinds
                      last:
                        description: A link to the last page of results. If a response does not contain
                          a last link, then direct navigation to the last page is not supported.
                        type: string
                        format: uri
                        nullable: true
                        example: https://api.confluent.cloud/v2/resourcekinds?page_token=bcAOehAY8F16YD84Z1wT
                      prev:
                        description: A link to the previous page of results. If a response does not contain
                          a prev link, then either there is no previous data or backwards traversal through
                          the result set is not supported.
                        type: string
                        format: uri
                        nullable: true
                        example: https://api.confluent.cloud/v2/resourcekinds?page_token=YIXRY97wWYmwzrax4dld
                      next:
                        description: A link to the next page of results. If a response does not contain
                          a next link, then there is no more data available.
                        type: string
                        format: uri
                        nullable: true
                        example: https://api.confluent.cloud/v2/resourcekinds?page_token=UvmDWOB1iwfAIBPj6EYb
                      total_size:
                        description: Number of records in the full result set. This response may be paginated
                          and have a smaller number of records.
                        type: integer
                        format: int32
                        minimum: 0
                        example: 123
                    title: ListMeta
                  data:
                    type: array
                    description: A data property that contains an array of resource items. Each entry
                      in the array is a separate resource.
                    items:
                      type: object
                      description: Represents a Materialized Table resource.
                      required:
                      - api_version
                      - kind
                      - metadata
                      - name
                      - organization_id
                      - environment_id
                      - spec
                      properties:
                        api_version:
                          type: string
                          enum:
                          - sql/v1
                          description: APIVersion defines the schema version of this representation of
                            a resource.
                          example: sql/v1
                          readOnly: true
                        kind:
                          type: string
                          description: Kind defines the object this REST resource represents.
                          enum:
                          - MaterializedTable
                          readOnly: true
                        metadata:
                          allOf:
                          - description: ObjectMeta is metadata that all persisted resources must have,
                              which includes all objects users must create.
                            required:
                            - self
                            properties:
                              self:
                                description: Self is a Uniform Resource Locator (URL) at which an object
                                  can be addressed. This URL encodes the service location, API version,
                                  and other particulars necessary to locate the resource at a point in
                                  time
                                type: string
                                format: uri
                                readOnly: true
                                example: https://api.confluent.cloud/v2/kafka-clusters/lkc-f3a90de
                              resource_name:
                                description: Resource Name is a Uniform Resource Identifier (URI) that
                                  is globally unique across space and time. It is represented as a Confluent
                                  Resource Name
                                type: string
                                format: uri
                                readOnly: true
                                example: crn://confluent.cloud/kafka=lkc-f3a90de
                              created_at:
                                type: string
                                format: date-time
                                example: '2006-01-02T15:04:05-07:00'
                                readOnly: true
                                description: The date and time at which this object was created. It is
                                  represented in RFC3339 format and is in UTC.
                              updated_at:
                                type: string
                                format: date-time
                                example: '2006-01-02T15:04:05-07:00'
                                readOnly: true
                                description: The date and time at which this object was last updated.
                                  It is represented in RFC3339 format and is in UTC.
                              deleted_at:
                                type: string
                                format: date-time
                                example: '2006-01-02T15:04:05-07:00'
                                readOnly: true
                                description: The date and time at which this object was (or will be) deleted.
                                  It is represented in RFC3339 format and is in UTC.
                            readOnly: true
                            title: ObjectMeta
                          - type: object
                            properties:
                              self:
                                example: https://flink.us-west1.aws.confluent.cloud/sql/v1/environments/env-123/databases/lkc-123/materialized-tables/high-value-orders
                              uid:
                                example: 12345678-1234-1234-1234-123456789012
                              resource_version:
                                example: a23av
                              resource_name:
                                example: ''
                              labels:
                                type: object
                                additionalProperties:
                                  type: string
                        name:
                          type: string
                          description: The user-provided name of the resource, unique within the Kafka
                            cluster. May contain ASCII alphanumerics, '.', '_' and '-'; must not be '.'
                            or '..'; max length 249.
                          pattern: ^[a-zA-Z0-9._-]+$
                          maxLength: 249
                          example: high-value-orders
                          x-immutable: true
                        organization_id:
                          type: string
                          format: uuid
                          description: The unique identifier for the organization.
                          x-immutable: true
                          readOnly: true
                        environment_id:
                          type: string
                          description: The unique identifier for the environment.
                          x-immutable: true
                          readOnly: true
                        spec:
                          type: object
                          description: The specifications of the Materialized Table.
                          properties:
                            kafka_cluster_id:
                              type: string
                              description: 'The ID of the Kafka cluster hosting the Materialized Table''s
                                topic.

                                This value must match the `kafka_cluster_id` path parameter.

                                It is immutable after creation and is ignored or rejected on update if
                                changed.'
                              example: lkc-12345
                              x-immutable: true
                            compute_pool_id:
                              type: string
                              description: 'The id associated with the compute pool in context.

                                If not specified, the materialized table will use the default compute
                                pool. The default pool is automatically determined by the system.'
                              example: lfcp-123
                            principal:
                              type: string
                              description: The id of a principal this Materialized Table query runs as.
                              example: sa-abc123
                              maxLength: 255
                            stopped:
                              type: boolean
                              description: Indicates whether the Materialized Table query should be stopped.
                              example: false
                            table_options:
                              type: object
                              description: Defines configuration properties for the table, equivalent
                                to the SQL 'WITH' clause
                              additionalProperties:
                                type: string
                              maxProperties: 8192
                            session_options:
                              type: object
                              description: Session configurations equivalent to the SQL 'SET' statement.
                                Only applicable on creation; ignored on update.
                              additionalProperties:
                                type: string
                              maxProperties: 8192
                              x-immutable: true
                            columns:
                              type: array
                              description: Details of each column in Materialized Table resource. If columns
                                are not specified, we infer from query. If it's specified it must be compatible
                                with the types in the query.
                              items:
                                type: object
                                description: Details of a column in the Materialized Table.
                                discriminator:
                                  propertyName: kind
                                  mapping:
                                    Physical:
                                      description: Physical columns define the structure of the table
                                        and the data types of its fields.
                                      allOf:
                                      - type: object
                                        required:
                                        - name
                                        - type
                                        properties:
                                          name:
                                            type: string
                                            description: The name of the column.
                                          type:
                                            type: object
                                            properties:
                                              type:
                                                type: string
                                                description: The data type of the column.
                                              nullable:
                                                type: boolean
                                                description: Indicates whether values in this column can
                                                  be null.
                                              length:
                                                type: integer
                                                format: int32
                                                description: The length of the data type.
                                              precision:
                                                type: integer
                                                format: int32
                                                description: The precision of the data type.
                                              scale:
                                                type: integer
                                                format: int32
                                                description: The scale of the data type.
                                              key_type:
                                                allOf:
                                                - circular(DataType)
                                                description: The type of the key in the data type (if
                                                  applicable).
                                              value_type:
                                                allOf:
                                                - circular(DataType)
                                                description: The type of the value in the data type (if
                                                  applicable).
                                              element_type:
                                                allOf:
                                                - circular(DataType)
                                                description: The type of the element in the data type
                                                  (if applicable).
                                              fields:
                                                type: array
                                                items:
                                                  type: object
                                                  properties:
                                                    name:
                                                      type: string
                                                      description: The name of the field.
                                                    field_type:
                                                      allOf:
                                                      - circular(DataType)
                                                      description: The data type of the field.
                                                    description:
                                                      type: string
                                                      description: The description of the field.
                                                  required:
                                                  - name
                                                  - field_type
                                                  title: RowFieldType
                                                description: The fields of the element in the data type
                                                  (if applicable).
                                              resolution:
                                                type: string
                                                description: The resolution of the data type (if applicable).
                                              fractional_precision:
                                                type: integer
                                                format: int32
                                                description: The fractional precision of the data type
                                                  (if applicable).
                                              class_name:
                                                type: string
                                                description: The class name of the structured data type
                                                  (if applicable).
                                            required:
                                            - type
                                            - nullable
                                            title: DataType
                                          comment:
                                            type: string
                                            description: A comment or description for the column.
                                        title: sql.v1.ColumnCommon
                                      - type: object
                                        required:
                                        - kind
                                        properties:
                                          name:
                                            example: user_id
                                          type:
                                            example:
                                              type: BIGINT
                                              nullable: false
                                          kind:
                                            type: string
                                            description: The kind of column.
                                            enum:
                                            - Physical
                                            example: Physical
                                      title: sql.v1.PhysicalColumn
                                    Metadata:
                                      description: Metadata columns reference system properties.
                                      allOf:
                                      - type: object
                                        required:
                                        - name
                                        - type
                                        properties:
                                          name:
                                            type: string
                                            description: The name of the column.
                                          type:
                                            type: object
                                            properties:
                                              type:
                                                type: string
                                                description: The data type of the column.
                                              nullable:
                                                type: boolean
                                                description: Indicates whether values in this column can
                                                  be null.
                                              length:
                                                type: integer
                                                format: int32
                                                description: The length of the data type.
                                              precision:
                                                type: integer
                                                format: int32
                                                description: The precision of the data type.
                                              scale:
                                                type: integer
                                                format: int32
                                                description: The scale of the data type.
                                              key_type:
                                                allOf:
                                                - circular(DataType)
                                                description: The type of the key in the data type (if
                                                  applicable).
                                              value_type:
                                                allOf:
                                                - circular(DataType)
                                                description: The type of the value in the data type (if
                                                  applicable).
                                              element_type:
                                                allOf:
                                                - circular(DataType)
                                                description: The type of the element in the data type
                                                  (if applicable).
                                              fields:
                                                type: array
                                                items:
                                                  type: object
                                                  properties:
                                                    name:
                                                      type: string
                                                      description: The name of the field.
                                                    field_type:
                                                      allOf:
                                                      - circular(DataType)
                                                      description: The data type of the field.
                                                    description:
                                                      type: string
                                                      description: The description of the field.
                                                  required:
                                                  - name
                                                  - field_type
                                                  title: RowFieldType
                                                description: The fields of the element in the data type
                                                  (if applicable).
                                              resolution:
                                                type: string
                                                description: The resolution of the data type (if applicable).
                                              fractional_precision:
                                                type: integer
                                                format: int32
                                                description: The fractional precision of the data type
                                                  (if applicable).
                                              class_name:
                                                type: string
                                                description: The class name of the structured data type
                                                  (if applicable).
                                            required:
                                            - type
                                            - nullable
                                            title: DataType
                                          comment:
                                            type: string
                                            description: A comment or description for the column.
                                        title: sql.v1.ColumnCommon
                                      - type: object
                                        required:
                                        - kind
                                        - metadata_key
                                        properties:
                                          name:
                                            example: table_offset
                                          type:
                                            example:
                                              type: BIGINT
                                              nullable: false
                                          kind:
                                            type: string
                                            description: The kind of column.
                                            enum:
                                            - Metadata
                                            example: Metadata
                                          metadata_key:
                                            type: string
                                            description: The system metadata key to reference.
                                            example: offset
                                          virtual:
                                            type: boolean
                                            description: Indicates if the metadata column is virtual.
                                            default: false
                                            example: true
                                      title: sql.v1.MetadataColumn
                                    Computed:
                                      description: Computed columns are generated via an expression.
                                      allOf:
                                      - type: object
                                        required:
                                        - name
                                        - type
                                        properties:
                                          name:
                                            type: string
                                            description: The name of the column.
                                          type:
                                            type: object
                                            properties:
                                              type:
                                                type: string
                                                description: The data type of the column.
                                              nullable:
                                                type: boolean
                                                description: Indicates whether values in this column can
                                                  be null.
                                              length:
                                                type: integer
                                                format: int32
                                                description: The length of the data type.
                                              precision:
                                                type: integer
                                                format: int32
                                                description: The precision of the data type.
                                              scale:
                                                type: integer
                                                format: int32
                                                description: The scale of the data type.
                                              key_type:
                                                allOf:
                                                - circular(DataType)
                                                description: The type of the key in the data type (if
                                                  applicable).
                                              value_type:
                                                allOf:
                                                - circular(DataType)
                                                description: The type of the value in the data type (if
                                                  applicable).
                                              element_type:
                                                allOf:
                                                - circular(DataType)
                                                description: The type of the element in the data type
                                                  (if applicable).
                                              fields:
                                                type: array
                                                items:
                                                  type: object
                                                  properties:
                                                    name:
                                                      type: string
                                                      description: The name of the field.
                                                    field_type:
                                                      allOf:
                                                      - circular(DataType)
                                                      description: The data type of the field.
                                                    description:
                                                      type: string
                                                      description: The description of the field.
                                                  required:
                                                  - name
                                                  - field_type
                                                  title: RowFieldType
                                                description: The fields of the element in the data type
                                                  (if applicable).
                                              resolution:
                                                type: string
                                                description: The resolution of the data type (if applicable).
                                              fractional_precision:
                                                type: integer
                                                format: int32
                                                description: The fractional precision of the data type
                                                  (if applicable).
                                              class_name:
                                                type: string
                                                description: The class name of the structured data type
                                                  (if applicable).
                                            required:
                                            - type
                                            - nullable
                                            title: DataType
                                          comment:
                                            type: string
                                            description: A comment or description for the column.
                                        title: sql.v1.ColumnCommon
                                      - type: object
                                        required:
                                        - kind
                                        - expression
                                        properties:
                                          name:
                                            example: total_price
                                          type:
                                            example:
                                              type: DECIMAL
                                              nullable: false
                                              precision: 10
                                              scale: 2
                                          kind:
                                            type: string
                                            description: The kind of column.
                                            enum:
                                            - Computed
                                            example: Computed
                                          expression:
                                            type: string
                                            description: The SQL expression used to compute the column
                                              value.
                                            example: quantity * price
                                          virtual:
                                            type: boolean
                                            description: Indicates if the computed column is virtual.
                                            default: false
                                            example: true
                                      title: sql.v1.ComputedColumn
                                oneOf:
                                - description: Physical columns define the structure of the table and
                                    the data types of its fields.
                                  allOf:
                                  - type: object
                                    required:
                                    - name
                                    - type
                                    properties:
                                      name:
                                        type: string
                                        description: The name of the column.
                                      type:
                                        type: object
                                        properties:
                                          type:
                                            type: string
                                            description: The data type of the column.
                                          nullable:
                                            type: boolean
                                            description: Indicates whether values in this column can be
                                              null.
                                          length:
                                            type: integer
                                            format: int32
                                            description: The length of the data type.
                                          precision:
                                            type: integer
                                            format: int32
                                            description: The precision of the data type.
                                          scale:
                                            type: integer
                                            format: int32
                                            description: The scale of the data type.
                                          key_type:
                                            allOf:
                                            - circular(DataType)
                                            description: The type of the key in the data type (if applicable).
                                          value_type:
                                            allOf:
                                            - circular(DataType)
                                            description: The type of the value in the data type (if applicable).
                                          element_type:
                                            allOf:
                                            - circular(DataType)
                                            description: The type of the element in the data type (if
                                              applicable).
                                          fields:
                                            type: array
                                            items:
                                              type: object
                                              properties:
                                                name:
                                                  type: string
                                                  description: The name of the field.
                                                field_type:
                                                  allOf:
                                                  - circular(DataType)
                                                  description: The data type of the field.
                                                description:
                                                  type: string
                                                  description: The description of the field.
                                              required:
                                              - name
                                              - field_type
                                              title: RowFieldType
                                            description: The fields of the element in the data type (if
                                              applicable).
                                          resolution:
                                            type: string
                                            description: The resolution of the data type (if applicable).
                                          fractional_precision:
                                            type: integer
                                            format: int32
                                            description: The fractional precision of the data type (if
                                              applicable).
                                          class_name:
                                            type: string
                                            description: The class name of the structured data type (if
                                              applicable).
                                        required:
                                        - type
                                        - nullable
                                        title: DataType
                                      comment:
                                        type: string
                                        description: A comment or description for the column.
                                    title: sql.v1.ColumnCommon
                                  - type: object
                                    required:
                                    - kind
                                    properties:
                                      name:
                                        example: user_id
                                      type:
                                        example:
                                          type: BIGINT
                                          nullable: false
                                      kind:
                                        type: string
                                        description: The kind of column.
                                        enum:
                                        - Physical
                                        example: Physical
                                  title: sql.v1.PhysicalColumn
                                - description: Metadata columns reference system properties.
                                  allOf:
                                  - type: object
                                    required:
                                    - name
                                    - type
                                    properties:
                                      name:
                                        type: string
                                        description: The name of the column.
                                      type:
                                        type: object
                                        properties:
                                          type:
                                            type: string
                                            description: The data type of the column.
                                          nullable:
                                            type: boolean
                                            description: Indicates whether values in this column can be
                                              null.
                                          length:
                                            type: integer
                                            format: int32
                                            description: The length of the data type.
                                          precision:
                                            type: integer
                                            format: int32
                                            description: The precision of the data type.
                                          scale:
                                            type: integer
                                            format: int32
                                            description: The scale of the data type.
                                          key_type:
                                            allOf:
                                            - circular(DataType)
                                            description: The type of the key in the data type (if applicable).
                                          value_type:
                                            allOf:
                                            - circular(DataType)
                                            description: The type of the value in the data type (if applicable).
                                          element_type:
                                            allOf:
                                            - circular(DataType)
                                            description: The type of the element in the data type (if
                                              applicable).
                                          fields:
                                            type: array
                                            items:
                                              type: object
                                              properties:
                                                name:
                                                  type: string
                                                  description: The name of the field.
                                                field_type:
                                                  allOf:
                                                  - circular(DataType)
                                                  description: The data type of the field.
                                                description:
                                                  type: string
                                                  description: The description of the field.
                                              required:
                                              - name
                                              - field_type
                                              title: RowFieldType
                                            description: The fields of the element in the data type (if
                                              applicable).
                                          resolution:
                                            type: string
                                            description: The resolution of the data type (if applicable).
                                          fractional_precision:
                                            type: integer
                                            format: int32
                                            description: The fractional precision of the data type (if
                                              applicable).
                                          class_name:
                                            type: string
                                            description: The class name of the structured data type (if
                                              applicable).
                                        required:
                                        - type
                                        - nullable
                                        title: DataType
                                      comment:
                                        type: string
                                        description: A comment or description for the column.
                                    title: sql.v1.ColumnCommon
                                  - type: object
                                    required:
                                    - kind
                                    - metadata_key
                                    properties:
                                      name:
                                        example: table_offset
                                      type:
                                        example:
                                          type: BIGINT
                                          nullable: false
                                      kind:
                                        type: string
                                        description: The kind of column.
                                        enum:
                                        - Metadata
                                        example: Metadata
                                      metadata_key:
                                        type: string
                                        description: The system metadata key to reference.
                                        example: offset
                                      virtual:
                                        type: boolean
                                        description: Indicates if the metadata column is virtual.
                                        default: false
                                        example: true
                                  title: sql.v1.MetadataColumn
                                - description: Computed columns are generated via an expression.
                                  allOf:
                                  - type: object
                                    required:
                                    - name
                                    - type
                                    properties:
                                      name:
                                        type: string
                                        description: The name of the column.
                                      type:
                                        type: object
                                        properties:
                                          type:
                                            type: string
                                            description: The data type of the column.
                                          nullable:
                                            type: boolean
                                            description: Indicates whether values in this column can be
                                              null.
                                          length:
                                            type: integer
                                            format: int32
                                            description: The length of the data type.
                                          precision:
                                            type: integer
                                            format: int32
                                            description: The precision of the data type.
                                          scale:
                                            type: integer
                                            format: int32
                                            description: The scale of the data type.
                                          key_type:
                                            allOf:
                                            - circular(DataType)
                                            description: The type of the key in the data type (if applicable).
                                          value_type:
                                            allOf:
                                            - circular(DataType)
                                            description: The type of the value in the data type (if applicable).
                                          element_type:
                                            allOf:
                                            - circular(DataType)
                                            description: The type of the element in the data type (if
                                              applicable).
                                          fields:
                                            type: array
                                            items:
                                              type: object
                                              properties:
                                                name:
                                                  type: string
                                                  description: The name of the field.
                                                field_type:
                                                  allOf:
                                                  - circular(DataType)
                                                  description: The data type of the field.
                                                description:
                                                  type: string
                                                  description: The description of the field.
                                              required:
                                              - name
                                              - field_type
                                              title: RowFieldType
                                            description: The fields of the element in the data type (if
                                              applicable).
                                          resolution:
                                            type: string
                                            description: The resolution of the data type (if applicable).
                                          fractional_precision:
                                            type: integer
                                            format: int32
                                            description: The fractional precision of the data type (if
                                              applicable).
                                          class_name:
                                            type: string
                                            description: The class name of the structured data type (if
                                              applicable).
                                        required:
                                        - type
                                        - nullable
                                        title: DataType
                                      comment:
                                        type: string
                                        description: A comment or description for the column.
                                    title: sql.v1.ColumnCommon
                                  - type: object
                                    required:
                                    - kind
                                    - expression
                                    properties:
                                      name:
                                        example: total_price
                                      type:
                                        example:
                                          type: DECIMAL
                                          nullable: false
                                          precision: 10
                                          scale: 2
                                      kind:
                                        type: string
                                        description: The kind of column.
                                        enum:
                                        - Computed
                                        example: Computed
                                      expression:
                                        type: string
                                        description: The SQL expression used to compute the column value.
                                        example: quantity * price
                                      virtual:
                                        type: boolean
                                        description: Indicates if the computed column is virtual.
                                        default: false
                                        example: true
                                  title: sql.v1.ComputedColumn
                                title: sql.v1.ColumnDetails
                            watermark:
                              type: object
                              description: Watermark strategy for the Materialized Table resource.
                              properties:
                                column:
                                  type: string
                                  example: event_timestamp
                                expression:
                                  type: string
                                  example: event_timestamp - INTERVAL '5' SECOND
                              title: sql.v1.Watermark
                            constraints:
                              type: array
                              description: Specify table constraints.
                              items:
                                type: object
                                description: A constraint on the materialized table.
                                properties:
                                  name:
                                    type: string
                                    example: pk_orders
                                  type:
                                    type: string
                                    description: The type of constraint.
                                    example: PRIMARY_KEY
                                    enum:
                                    - PRIMARY_KEY
                                  columns:
                                    type: array
                                    items:
                                      type: string
                                    example:
                                    - user_id
                                    - product_id
                                  enforced:
                                    type: boolean
                                    description: Whether the constraint is enforced.
                                    default: false
                                title: sql.v1.Constraint
                            distribution:
                              description: Only applicable on creation; ignored on update.
                              x-immutable: true
                              allOf:
                              - type: object
                                description: Distribution (bucket by) strategy.
                                required:
                                - kind
                                properties:
                                  kind:
                                    type: string
                                    description: The kind of distribution.
                                    example: HASH
                                    enum:
                                    - HASH
                                  keys:
                                    type: array
                                    items:
                                      type: string
                                    example:
                                    - user_id
                                  bucket_count:
                                    type: integer
                                    format: int32
                                    minimum: 1
                                    default: 6
                                    description: The number of buckets.
                                    example: 12
                                title: sql.v1.Distribution
                            query:
                              type: string
                              description: Contains the query section (usually starting with a SELECT)
                                of the latest Materialized Table.
                              example: SELECT user_id, product_id, price, quantity FROM orders WHERE price
                                > 1000;
                              maxLength: 131072
                          title: sql.v1.MaterializedTableSpec
                        status:
                          readOnly: true
                          allOf:
                          - type: object
                            description: The status of the Materialized Table.
                            properties:
                              phase:
                                type: string
                                description: The lifecycle phase of the materialized table.
                                example: RUNNING
                                enum:
                                - PENDING
                                - RUNNING
                                - COMPLETED
                                - DELETING
                                - FAILING
                                - FAILED
                                - CREATING
                                - ALTERING
                                - DEGRADED
                                - STOPPING
                                - STOPPED
                              detail:
                                type: string
                                description: Optional. Human-readable description of phase.
                                example: Materialized table is running.
                              warnings:
                                type: array
                                description: List of warnings encountered during materialized table execution.
                                items:
                                  type: object
                                  description: Represents a non-fatal issue encountered during materialized
                                    table processing.
                                  allOf:
                                  - type: object
                                    description: Represents a non-fatal issue encountered during statement
                                      processing.
                                    required:
                                    - severity
                                    - created_at
                                    - reason
                                    - message
                                    properties:
                                      severity:
                                        type: string
                                        description: 'Indicates the severity of the warning.


                                          LOW: Indicates a low severity warning and for informing the
                                          user.


                                          MODERATE: Indicates a moderate severity warning and may require
                                          user action. Could cause degraded statements if certain conditions
                                          apply.


                                          CRITICAL: Indicates a critical severity warning and requires
                                          user action. It will cause degraded statements eventually.

                                          '
                                        example: MODERATE
                                        enum:
                                        - LOW
                                        - MODERATE
                                        - CRITICAL
                                        title: sql.v1.WarningSeverity
                                      created_at:
                                        type: string
                                        format: date-time
                                        description: The timestamp when the warning was created. It is
                                          represented in RFC3339 format and is in UTC.
                                        example: '2025-11-10T16:20:00Z'
                                        readOnly: true
                                      reason:
                                        type: string
                                        description: A machine-readable short, upper case summary delimited
                                          by underscore.
                                        example: MISSING_WINDOW_START_END
                                      message:
                                        type: string
                                        description: A human-readable string containing the description
                                          of the warning.
                                        example: The statement is missing window start and end bounds
                                          which may lead to unbounded state growth.
                                    title: sql.v1.StatementWarning
                                  title: sql.v1.MaterializedTableWarning
                              creation_statement:
                                type: string
                                description: Entire Materialized Table statement as submitted by user
                                  e.g CREATE OR ALTER MATERIALIZED TABLE ...
                                example: CREATE OR ALTER MATERIALIZED TABLE high-value-orders AS SELECT
                                  user_id, product_id, price, quantity FROM orders WHERE price > 1000;
                              scaling_status:
                                description: Scaling status for this statement.
                                type: object
                                properties:
                                  scaling_state:
                                    description: 'OK: The statement runs at the right scale.


                                      PENDING_SCALE_DOWN: The statement requires less resources, and will
                                      be scaled down in the near future.


                                      PENDING_SCALE_UP: The statement requires more resources, and will
                                      be scaled up in the near future.


                                      POOL_EXHAUSTED: The statement requires more resources, but not enough
                                      resources are available.

                                      '
                                    example: OK
                                    readOnly: true
                                    type: string
                                    enum:
                                    - OK
                                    - PENDING_SCALE_DOWN
                                    - PENDING_SCALE_UP
                                    - POOL_EXHAUSTED
                                  last_updated:
                                    description: The last time the scaling status was updated.
                                    example: '1996-03-19 01:02:03-04:05'
                                    format: date-time
                                    readOnly: true
                                    type: string
                                readOnly: true
                                title: sql.v1.ScalingStatus
                              version:
                                type: integer
                                format: int32
                                minimum: 1
                                description: Represents the evolution history of the Materialized Table.
                                  The current value indicates the latest version.
                                example: 3
                              latest_version:
                                type: integer
                                format: int32
                                minimum: 1
                                description: Represents the latest submitted version of the Materialized
                                  Table. When a query evolution is accepted, `latest_version` is incremented
                                  immediately and will be greater than `version` until the new query is
                                  fully activated.
                                example: 4
                            title: sql.v1.MaterializedTableStatus
                      title: sql.v1.MaterializedTable
                    uniqueItems: true
                title: sql.v1.MaterializedTableList
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
        '400':
          description: Bad Request
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
          content:
            application/json:
              schema:
                type: object
                description: Provides information about problems encountered while performing an operation.
                required:
                - errors
                properties:
                  errors:
                    description: List of errors which caused this operation to fail
                    type: array
                    items:
                      type: object
                      description: Describes a particular error encountered while performing an operation.
                      properties:
                        id:
                          description: A unique identifier for this particular occurrence of the problem.
                          type: string
                          maxLength: 255
                        status:
                          description: The HTTP status code applicable to this problem, expressed as a
                            string value.
                          type: string
                        code:
                          description: An application-specific error code, expressed as a string value.
                          type: string
                        title:
                          description: A short, human-readable summary of the problem. It **SHOULD NOT**
                            change from occurrence to occurrence of the problem, except for purposes of
                            localization.
                          type: string
                        detail:
                          description: A human-readable explanation specific to this occurrence of the
                            problem.
                          type: string
                        source:
                          type: object
                          description: If this error was caused by a particular part of the API request,
                            the source will point to the query string parameter or request body property
                            that caused it.
                          properties:
                            pointer:
                              description: A JSON Pointer [RFC6901] to the associated entity in the request
                                document [e.g. "/spec" for a spec object, or "/spec/title" for a specific
                                field].
                              type: string
                            parameter:
                              description: A string indicating which query parameter caused the error.
                              type: string
                        error_code:
                          type: integer
                          format: int32
                        message:
                          type: string
                          nullable: true
                      additionalProperties: false
                      title: Error
                    uniqueItems: true
                title: Failure
              example:
                errors:
                - id: ed42afdc-f0d5-4c0d-b428-9fc6ed6e279d
                  status: '400'
                  code: invalid_filter
                  title: Invalid Filter
                  detail: The 'delorean' resource can't be filtered by 'num_doors'
                  source:
                    parameter: num_doors
        '401':
          x-summary: Unauthorized
          description: The request lacks valid authentication credentials for this resource.
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
            WWW-Authenticate:
              schema:
                type: string
              description: The unique identifier for the API request.
              example: Basic error="invalid_key", error_description="The API Key is invalid"
          content:
            application/json:
              schema:
                type: object
                description: Provides information about problems encountered while performing an operation.
                required:
                - errors
                properties:
                  errors:
                    description: List of errors which caused this operation to fail
                    type: array
                    items:
                      type: object
                      description: Describes a particular error encountered while performing an operation.
                      properties:
                        id:
                          description: A unique identifier for this particular occurrence of the problem.
                          type: string
                          maxLength: 255
                        status:
                          description: The HTTP status code applicable to this problem, expressed as a
                            string value.
                          type: string
                        code:
                          description: An application-specific error code, expressed as a string value.
                          type: string
                        title:
                          description: A short, human-readable summary of the problem. It **SHOULD NOT**
                            change from occurrence to occurrence of the problem, except for purposes of
                            localization.
                          type: string
                        detail:
                          description: A human-readable explanation specific to this occurrence of the
                            problem.
                          type: string
                        source:
                          type: object
                          description: If this error was caused by a particular part of the API request,
                            the source will point to the query string parameter or request body property
                            that caused it.
                          properties:
                            pointer:
                              description: A JSON Pointer [RFC6901] to the associated entity in the request
                                document [e.g. "/spec" for a spec object, or "/spec/title" for a specific
                                field].
                              type: string
                            parameter:
                              description: A string indicating which query parameter caused the error.
                              type: string
                        error_code:
                          type: integer
                          format: int32
                        message:
                          type: string
                          nullable: true
                      additionalProperties: false
                      title: Error
                    uniqueItems: true
                title: Failure
              example:
                errors:
                - id: ed42afdc-f0d5-4c0d-b428-9fc6ed6e279d
                  status: '401'
                  code: user_unauthenticated
                  title: Authentication Required
                  detail: Valid authentication credentials must be provided
        '403':
          x-summary: Forbidden
          description: The access credentials were considered insufficient to grant access
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
          content:
            application/json:
              schema:
                type: object
                description: Provides information about problems encountered while performing an operation.
                required:
                - errors
                properties:
                  errors:
                    description: List of errors which caused this operation to fail
                    type: array
                    items:
                      type: object
                      description: Describes a particular error encountered while performing an operation.
                      properties:
                        id:
                          description: A unique identifier for this particular occurrence of the problem.
                          type: string
                          maxLength: 255
                        status:
                          description: The HTTP status code applicable to this problem, expressed as a
                            string value.
                          type: string
                        code:
                          description: An application-specific error code, expressed as a string value.
                          type: string
                        title:
                          description: A short, human-readable summary of the problem. It **SHOULD NOT**
                            change from occurrence to occurrence of the problem, except for purposes of
                            localization.
                          type: string
                        detail:
                          description: A human-readable explanation specific to this occurrence of the
                            problem.
                          type: string
                        source:
                          type: object
                          description: If this error was caused by a particular part of the API request,
                            the source will point to the query string parameter or request body property
                            that caused it.
                          properties:
                            pointer:
                              description: A JSON Pointer [RFC6901] to the associated entity in the request
                                document [e.g. "/spec" for a spec object, or "/spec/title" for a specific
                                field].
                              type: string
                            parameter:
                              description: A string indicating which query parameter caused the error.
                              type: string
                        error_code:
                          type: integer
                          format: int32
                        message:
                          type: string
                          nullable: true
                      additionalProperties: false
                      title: Error
                    uniqueItems: true
                title: Failure
              example:
                errors:
                - id: ed42afdc-f0d5-4c0d-b428-9fc6ed6e279d
                  status: '403'
                  code: user_unauthorized
                  title: User Access Unauthorized
                  detail: The user 'mcfly' is not allowed to access the 'delorean' resource without the
                    'plutonium' role.
        '404':
          description: Not Found
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
          content:
            application/json:
              schema:
                type: object
                description: Provides information about problems encountered while performing an operation.
                required:
                - errors
                properties:
                  errors:
                    description: List of errors which caused this operation to fail
                    type: array
                    items:
                      type: object
                      description: Describes a particular error encountered while performing an operation.
                      properties:
                        id:
                          description: A unique identifier for this particular occurrence of the problem.
                          type: string
                          maxLength: 255
                        status:
                          description: The HTTP status code applicable to this problem, expressed as a
                            string value.
                          type: string
                        code:
                          description: An application-specific error code, expressed as a string value.
                          type: string
                        title:
                          description: A short, human-readable summary of the problem. It **SHOULD NOT**
                            change from occurrence to occurrence of the problem, except for purposes of
                            localization.
                          type: string
                        detail:
                          description: A human-readable explanation specific to this occurrence of the
                            problem.
                          type: string
                        source:
                          type: object
                          description: If this error was caused by a particular part of the API request,
                            the source will point to the query string parameter or request body property
                            that caused it.
                          properties:
                            pointer:
                              description: A JSON Pointer [RFC6901] to the associated entity in the request
                                document [e.g. "/spec" for a spec object, or "/spec/title" for a specific
                                field].
                              type: string
                            parameter:
                              description: A string indicating which query parameter caused the error.
                              type: string
                        error_code:
                          type: integer
                          format: int32
                        message:
                          type: string
                          nullable: true
                      additionalProperties: false
                      title: Error
                    uniqueItems: true
                title: Failure
              example:
                errors:
                - id: ed42afdc-f0d5-4c0d-b428-9fc6ed6e279d
                  status: '404'
                  title: Not Found
        '429':
          description: Rate Limit Exceeded
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
            X-RateLimit-Limit:
              schema:
                type: integer
              description: The maximum number of requests you're permitted to make per time period.
            X-RateLimit-Remaining:
              schema:
                type: integer
              description: The number of requests remaining in the current rate limit window.
            X-RateLimit-Reset:
              schema:
                type: integer
              description: "The relative time in seconds until the current rate-limit window resets. \
                \ \n  \n**Important:** This differs from Github and Twitter's same-named header which\
                \ uses UTC epoch seconds. We use relative time to avoid client/server time synchronization\
                \ issues."
            Retry-After:
              schema:
                type: integer
              description: The number of seconds to wait until the rate limit window resets. Only sent
                when the rate limit is reached.
        '500':
          description: Oops, something went wrong!
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
          content:
            application/json:
              schema:
                type: object
                description: Provides information about problems encountered while performing an operation.
                required:
                - errors
                properties:
                  errors:
                    description: List of errors which caused this operation to fail
                    type: array
                    items:
                      type: object
                      description: Describes a particular error encountered while performing an operation.
                      properties:
                        id:
                          description: A unique identifier for this particular occurrence of the problem.
                          type: string
                          maxLength: 255
                        status:
                          description: The HTTP status code applicable to this problem, expressed as a
                            string value.
                          type: string
                        code:
                          description: An application-specific error code, expressed as a string value.
                          type: string
                        title:
                          description: A short, human-readable summary of the problem. It **SHOULD NOT**
                            change from occurrence to occurrence of the problem, except for purposes of
                            localization.
                          type: string
                        detail:
                          description: A human-readable explanation specific to this occurrence of the
                            problem.
                          type: string
                        source:
                          type: object
                          description: If this error was caused by a particular part of the API request,
                            the source will point to the query string parameter or request body property
                            that caused it.
                          properties:
                            pointer:
                              description: A JSON Pointer [RFC6901] to the associated entity in the request
                                document [e.g. "/spec" for a spec object, or "/spec/title" for a specific
                                field].
                              type: string
                            parameter:
                              description: A string indicating which query parameter caused the error.
                              type: string
                        error_code:
                          type: integer
                          format: int32
                        message:
                          type: string
                          nullable: true
                      additionalProperties: false
                      title: Error
                    uniqueItems: true
                title: Failure
              example:
                errors:
                - id: ed42afdc-f0d5-4c0d-b428-9fc6ed6e279d
                  status: '500'
                  code: out_of_gas
                  title: DeLorean Out Of Gas
                  detail: The DeLorean has run out of gas, but Doc Brown will fill 'er up for you asap
      servers:
      - url: https://flink.region.provider.confluent.cloud
        description: Flink Compute Pool Endpoint